const Input = (parent) => {
  const div = document.createElement('div')
  div.classList.add('input')
  parent.append(div)
  const input = document.createElement('input')
  div.append(input)

  let clearable = null
  let getFunction = null
  const setFunction = value => {
    input.value = value
    div.classList.toggle('clearable', clearable && value !== null)
    if (getFunction && typeof getFunction === 'function') {
      getFunction(value)
    }
  }

  input.oninput = event => {
    setFunction(event.target.value)
  }

  const prop = (name, p) => {
    switch (name) {
      case 'clearable':
        if (p) {
          clearable = Icon(parent, 'clear')
          clearable.classList.add('toggle')
          div.append(clearable)
          clearable.onclick = event => {
            event.stopPropagation()
            setFunction(null)
          }
          div.classList.toggle('clearable', input.value !== null)
        } else {
          if (clearable) {
            clearable.remove()
          }
        }
        break;

      case 'set':
        setFunction(p)
        break;

      case 'get':
        getFunction = p
        break;

      case 'icon-after':
        const iconAfter = Icon(div, p)
        iconAfter.classList.add('icon-after')
        div.classList.add('icon-after')
        break;

      case 'icon-before':
        const iconBefore = Icon(div, p)
        iconBefore.classList.add('icon-before')
        div.classList.add('icon-before')
        break;
    
      case 'readonly':
        input.setAttribute('readonly', p)
        break;
      default:
        break;
    }

    return { prop }
  }
  return { prop }
}

module.exports = {
  Input
}

